package com.google.android.overtheair.v1;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 * <pre>
 * ## Service for Android Over the Air(OTA).
 * ## ----  deployment related rpcs              ---
 * </pre>
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.10.0)",
    comments = "Source: google/android/overtheair/v1/overtheair_service.proto")
public final class OverTheAirServiceGrpc {

  private OverTheAirServiceGrpc() {}

  public static final String SERVICE_NAME = "google.android.overtheair.v1.OverTheAirService";

  // Static method descriptors that strictly reflect the proto.
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetDeploymentMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> METHOD_GET_DEPLOYMENT = getGetDeploymentMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getGetDeploymentMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getGetDeploymentMethod() {
    return getGetDeploymentMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getGetDeploymentMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetDeploymentRequest, com.google.android.overtheair.v1.Deployment> getGetDeploymentMethod;
    if ((getGetDeploymentMethod = OverTheAirServiceGrpc.getGetDeploymentMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetDeploymentMethod = OverTheAirServiceGrpc.getGetDeploymentMethod) == null) {
          OverTheAirServiceGrpc.getGetDeploymentMethod = getGetDeploymentMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetDeploymentRequest, com.google.android.overtheair.v1.Deployment>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetDeployment"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetDeploymentRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Deployment.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetDeployment"))
                  .build();
          }
        }
     }
     return getGetDeploymentMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListDeploymentsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListDeploymentsRequest,
      com.google.android.overtheair.v1.ListDeploymentsResponse> METHOD_LIST_DEPLOYMENTS = getListDeploymentsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListDeploymentsRequest,
      com.google.android.overtheair.v1.ListDeploymentsResponse> getListDeploymentsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListDeploymentsRequest,
      com.google.android.overtheair.v1.ListDeploymentsResponse> getListDeploymentsMethod() {
    return getListDeploymentsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListDeploymentsRequest,
      com.google.android.overtheair.v1.ListDeploymentsResponse> getListDeploymentsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListDeploymentsRequest, com.google.android.overtheair.v1.ListDeploymentsResponse> getListDeploymentsMethod;
    if ((getListDeploymentsMethod = OverTheAirServiceGrpc.getListDeploymentsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListDeploymentsMethod = OverTheAirServiceGrpc.getListDeploymentsMethod) == null) {
          OverTheAirServiceGrpc.getListDeploymentsMethod = getListDeploymentsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListDeploymentsRequest, com.google.android.overtheair.v1.ListDeploymentsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListDeployments"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListDeploymentsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListDeploymentsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListDeployments"))
                  .build();
          }
        }
     }
     return getListDeploymentsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdateDeploymentMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> METHOD_UPDATE_DEPLOYMENT = getUpdateDeploymentMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getUpdateDeploymentMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getUpdateDeploymentMethod() {
    return getUpdateDeploymentMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateDeploymentRequest,
      com.google.android.overtheair.v1.Deployment> getUpdateDeploymentMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateDeploymentRequest, com.google.android.overtheair.v1.Deployment> getUpdateDeploymentMethod;
    if ((getUpdateDeploymentMethod = OverTheAirServiceGrpc.getUpdateDeploymentMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdateDeploymentMethod = OverTheAirServiceGrpc.getUpdateDeploymentMethod) == null) {
          OverTheAirServiceGrpc.getUpdateDeploymentMethod = getUpdateDeploymentMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdateDeploymentRequest, com.google.android.overtheair.v1.Deployment>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdateDeployment"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateDeploymentRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Deployment.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdateDeployment"))
                  .build();
          }
        }
     }
     return getUpdateDeploymentMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetPackageMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetPackageRequest,
      com.google.android.overtheair.v1.Package> METHOD_GET_PACKAGE = getGetPackageMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetPackageRequest,
      com.google.android.overtheair.v1.Package> getGetPackageMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetPackageRequest,
      com.google.android.overtheair.v1.Package> getGetPackageMethod() {
    return getGetPackageMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetPackageRequest,
      com.google.android.overtheair.v1.Package> getGetPackageMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetPackageRequest, com.google.android.overtheair.v1.Package> getGetPackageMethod;
    if ((getGetPackageMethod = OverTheAirServiceGrpc.getGetPackageMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetPackageMethod = OverTheAirServiceGrpc.getGetPackageMethod) == null) {
          OverTheAirServiceGrpc.getGetPackageMethod = getGetPackageMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetPackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetPackage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetPackageRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Package.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetPackage"))
                  .build();
          }
        }
     }
     return getGetPackageMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListPackagesMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListPackagesRequest,
      com.google.android.overtheair.v1.ListPackagesResponse> METHOD_LIST_PACKAGES = getListPackagesMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListPackagesRequest,
      com.google.android.overtheair.v1.ListPackagesResponse> getListPackagesMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListPackagesRequest,
      com.google.android.overtheair.v1.ListPackagesResponse> getListPackagesMethod() {
    return getListPackagesMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListPackagesRequest,
      com.google.android.overtheair.v1.ListPackagesResponse> getListPackagesMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListPackagesRequest, com.google.android.overtheair.v1.ListPackagesResponse> getListPackagesMethod;
    if ((getListPackagesMethod = OverTheAirServiceGrpc.getListPackagesMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListPackagesMethod = OverTheAirServiceGrpc.getListPackagesMethod) == null) {
          OverTheAirServiceGrpc.getListPackagesMethod = getListPackagesMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListPackagesRequest, com.google.android.overtheair.v1.ListPackagesResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListPackages"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListPackagesResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListPackages"))
                  .build();
          }
        }
     }
     return getListPackagesMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDeletePackageMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeletePackageRequest,
      com.google.android.overtheair.v1.DeletePackageResponse> METHOD_DELETE_PACKAGE = getDeletePackageMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeletePackageRequest,
      com.google.android.overtheair.v1.DeletePackageResponse> getDeletePackageMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeletePackageRequest,
      com.google.android.overtheair.v1.DeletePackageResponse> getDeletePackageMethod() {
    return getDeletePackageMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeletePackageRequest,
      com.google.android.overtheair.v1.DeletePackageResponse> getDeletePackageMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeletePackageRequest, com.google.android.overtheair.v1.DeletePackageResponse> getDeletePackageMethod;
    if ((getDeletePackageMethod = OverTheAirServiceGrpc.getDeletePackageMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDeletePackageMethod = OverTheAirServiceGrpc.getDeletePackageMethod) == null) {
          OverTheAirServiceGrpc.getDeletePackageMethod = getDeletePackageMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DeletePackageRequest, com.google.android.overtheair.v1.DeletePackageResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DeletePackage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeletePackageRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeletePackageResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DeletePackage"))
                  .build();
          }
        }
     }
     return getDeletePackageMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdatePackageMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdatePackageRequest,
      com.google.android.overtheair.v1.Package> METHOD_UPDATE_PACKAGE = getUpdatePackageMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdatePackageRequest,
      com.google.android.overtheair.v1.Package> getUpdatePackageMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdatePackageRequest,
      com.google.android.overtheair.v1.Package> getUpdatePackageMethod() {
    return getUpdatePackageMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdatePackageRequest,
      com.google.android.overtheair.v1.Package> getUpdatePackageMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdatePackageRequest, com.google.android.overtheair.v1.Package> getUpdatePackageMethod;
    if ((getUpdatePackageMethod = OverTheAirServiceGrpc.getUpdatePackageMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdatePackageMethod = OverTheAirServiceGrpc.getUpdatePackageMethod) == null) {
          OverTheAirServiceGrpc.getUpdatePackageMethod = getUpdatePackageMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdatePackageRequest, com.google.android.overtheair.v1.Package>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdatePackage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdatePackageRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Package.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdatePackage"))
                  .build();
          }
        }
     }
     return getUpdatePackageMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getCreateConfigMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateConfigRequest,
      com.google.android.overtheair.v1.Config> METHOD_CREATE_CONFIG = getCreateConfigMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateConfigRequest,
      com.google.android.overtheair.v1.Config> getCreateConfigMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateConfigRequest,
      com.google.android.overtheair.v1.Config> getCreateConfigMethod() {
    return getCreateConfigMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateConfigRequest,
      com.google.android.overtheair.v1.Config> getCreateConfigMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateConfigRequest, com.google.android.overtheair.v1.Config> getCreateConfigMethod;
    if ((getCreateConfigMethod = OverTheAirServiceGrpc.getCreateConfigMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getCreateConfigMethod = OverTheAirServiceGrpc.getCreateConfigMethod) == null) {
          OverTheAirServiceGrpc.getCreateConfigMethod = getCreateConfigMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.CreateConfigRequest, com.google.android.overtheair.v1.Config>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "CreateConfig"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.CreateConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Config.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("CreateConfig"))
                  .build();
          }
        }
     }
     return getCreateConfigMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetConfigMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetConfigRequest,
      com.google.android.overtheair.v1.Config> METHOD_GET_CONFIG = getGetConfigMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetConfigRequest,
      com.google.android.overtheair.v1.Config> getGetConfigMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetConfigRequest,
      com.google.android.overtheair.v1.Config> getGetConfigMethod() {
    return getGetConfigMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetConfigRequest,
      com.google.android.overtheair.v1.Config> getGetConfigMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetConfigRequest, com.google.android.overtheair.v1.Config> getGetConfigMethod;
    if ((getGetConfigMethod = OverTheAirServiceGrpc.getGetConfigMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetConfigMethod = OverTheAirServiceGrpc.getGetConfigMethod) == null) {
          OverTheAirServiceGrpc.getGetConfigMethod = getGetConfigMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetConfigRequest, com.google.android.overtheair.v1.Config>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetConfig"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Config.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetConfig"))
                  .build();
          }
        }
     }
     return getGetConfigMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListConfigsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsRequest,
      com.google.android.overtheair.v1.ListConfigsResponse> METHOD_LIST_CONFIGS = getListConfigsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsRequest,
      com.google.android.overtheair.v1.ListConfigsResponse> getListConfigsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsRequest,
      com.google.android.overtheair.v1.ListConfigsResponse> getListConfigsMethod() {
    return getListConfigsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsRequest,
      com.google.android.overtheair.v1.ListConfigsResponse> getListConfigsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsRequest, com.google.android.overtheair.v1.ListConfigsResponse> getListConfigsMethod;
    if ((getListConfigsMethod = OverTheAirServiceGrpc.getListConfigsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListConfigsMethod = OverTheAirServiceGrpc.getListConfigsMethod) == null) {
          OverTheAirServiceGrpc.getListConfigsMethod = getListConfigsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListConfigsRequest, com.google.android.overtheair.v1.ListConfigsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListConfigs"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListConfigs"))
                  .build();
          }
        }
     }
     return getListConfigsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDeleteConfigMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteConfigRequest,
      com.google.android.overtheair.v1.DeleteConfigResponse> METHOD_DELETE_CONFIG = getDeleteConfigMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteConfigRequest,
      com.google.android.overtheair.v1.DeleteConfigResponse> getDeleteConfigMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteConfigRequest,
      com.google.android.overtheair.v1.DeleteConfigResponse> getDeleteConfigMethod() {
    return getDeleteConfigMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteConfigRequest,
      com.google.android.overtheair.v1.DeleteConfigResponse> getDeleteConfigMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteConfigRequest, com.google.android.overtheair.v1.DeleteConfigResponse> getDeleteConfigMethod;
    if ((getDeleteConfigMethod = OverTheAirServiceGrpc.getDeleteConfigMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDeleteConfigMethod = OverTheAirServiceGrpc.getDeleteConfigMethod) == null) {
          OverTheAirServiceGrpc.getDeleteConfigMethod = getDeleteConfigMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DeleteConfigRequest, com.google.android.overtheair.v1.DeleteConfigResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DeleteConfig"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteConfigResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DeleteConfig"))
                  .build();
          }
        }
     }
     return getDeleteConfigMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdateConfigMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigRequest,
      com.google.android.overtheair.v1.Config> METHOD_UPDATE_CONFIG = getUpdateConfigMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigRequest,
      com.google.android.overtheair.v1.Config> getUpdateConfigMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigRequest,
      com.google.android.overtheair.v1.Config> getUpdateConfigMethod() {
    return getUpdateConfigMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigRequest,
      com.google.android.overtheair.v1.Config> getUpdateConfigMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigRequest, com.google.android.overtheair.v1.Config> getUpdateConfigMethod;
    if ((getUpdateConfigMethod = OverTheAirServiceGrpc.getUpdateConfigMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdateConfigMethod = OverTheAirServiceGrpc.getUpdateConfigMethod) == null) {
          OverTheAirServiceGrpc.getUpdateConfigMethod = getUpdateConfigMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdateConfigRequest, com.google.android.overtheair.v1.Config>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdateConfig"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Config.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdateConfig"))
                  .build();
          }
        }
     }
     return getUpdateConfigMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getCreateGroupMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupRequest,
      com.google.android.overtheair.v1.Group> METHOD_CREATE_GROUP = getCreateGroupMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupRequest,
      com.google.android.overtheair.v1.Group> getCreateGroupMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupRequest,
      com.google.android.overtheair.v1.Group> getCreateGroupMethod() {
    return getCreateGroupMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupRequest,
      com.google.android.overtheair.v1.Group> getCreateGroupMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupRequest, com.google.android.overtheair.v1.Group> getCreateGroupMethod;
    if ((getCreateGroupMethod = OverTheAirServiceGrpc.getCreateGroupMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getCreateGroupMethod = OverTheAirServiceGrpc.getCreateGroupMethod) == null) {
          OverTheAirServiceGrpc.getCreateGroupMethod = getCreateGroupMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.CreateGroupRequest, com.google.android.overtheair.v1.Group>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "CreateGroup"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.CreateGroupRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Group.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("CreateGroup"))
                  .build();
          }
        }
     }
     return getCreateGroupMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetGroupMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupRequest,
      com.google.android.overtheair.v1.Group> METHOD_GET_GROUP = getGetGroupMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupRequest,
      com.google.android.overtheair.v1.Group> getGetGroupMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupRequest,
      com.google.android.overtheair.v1.Group> getGetGroupMethod() {
    return getGetGroupMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupRequest,
      com.google.android.overtheair.v1.Group> getGetGroupMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupRequest, com.google.android.overtheair.v1.Group> getGetGroupMethod;
    if ((getGetGroupMethod = OverTheAirServiceGrpc.getGetGroupMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetGroupMethod = OverTheAirServiceGrpc.getGetGroupMethod) == null) {
          OverTheAirServiceGrpc.getGetGroupMethod = getGetGroupMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetGroupRequest, com.google.android.overtheair.v1.Group>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetGroup"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetGroupRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Group.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetGroup"))
                  .build();
          }
        }
     }
     return getGetGroupMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListGroupsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupsRequest,
      com.google.android.overtheair.v1.ListGroupsResponse> METHOD_LIST_GROUPS = getListGroupsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupsRequest,
      com.google.android.overtheair.v1.ListGroupsResponse> getListGroupsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupsRequest,
      com.google.android.overtheair.v1.ListGroupsResponse> getListGroupsMethod() {
    return getListGroupsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupsRequest,
      com.google.android.overtheair.v1.ListGroupsResponse> getListGroupsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupsRequest, com.google.android.overtheair.v1.ListGroupsResponse> getListGroupsMethod;
    if ((getListGroupsMethod = OverTheAirServiceGrpc.getListGroupsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListGroupsMethod = OverTheAirServiceGrpc.getListGroupsMethod) == null) {
          OverTheAirServiceGrpc.getListGroupsMethod = getListGroupsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListGroupsRequest, com.google.android.overtheair.v1.ListGroupsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListGroups"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListGroups"))
                  .build();
          }
        }
     }
     return getListGroupsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDeleteGroupMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupRequest,
      com.google.android.overtheair.v1.DeleteGroupResponse> METHOD_DELETE_GROUP = getDeleteGroupMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupRequest,
      com.google.android.overtheair.v1.DeleteGroupResponse> getDeleteGroupMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupRequest,
      com.google.android.overtheair.v1.DeleteGroupResponse> getDeleteGroupMethod() {
    return getDeleteGroupMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupRequest,
      com.google.android.overtheair.v1.DeleteGroupResponse> getDeleteGroupMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupRequest, com.google.android.overtheair.v1.DeleteGroupResponse> getDeleteGroupMethod;
    if ((getDeleteGroupMethod = OverTheAirServiceGrpc.getDeleteGroupMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDeleteGroupMethod = OverTheAirServiceGrpc.getDeleteGroupMethod) == null) {
          OverTheAirServiceGrpc.getDeleteGroupMethod = getDeleteGroupMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DeleteGroupRequest, com.google.android.overtheair.v1.DeleteGroupResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DeleteGroup"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DeleteGroup"))
                  .build();
          }
        }
     }
     return getDeleteGroupMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdateGroupMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupRequest,
      com.google.android.overtheair.v1.Group> METHOD_UPDATE_GROUP = getUpdateGroupMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupRequest,
      com.google.android.overtheair.v1.Group> getUpdateGroupMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupRequest,
      com.google.android.overtheair.v1.Group> getUpdateGroupMethod() {
    return getUpdateGroupMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupRequest,
      com.google.android.overtheair.v1.Group> getUpdateGroupMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupRequest, com.google.android.overtheair.v1.Group> getUpdateGroupMethod;
    if ((getUpdateGroupMethod = OverTheAirServiceGrpc.getUpdateGroupMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdateGroupMethod = OverTheAirServiceGrpc.getUpdateGroupMethod) == null) {
          OverTheAirServiceGrpc.getUpdateGroupMethod = getUpdateGroupMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdateGroupRequest, com.google.android.overtheair.v1.Group>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdateGroup"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateGroupRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Group.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdateGroup"))
                  .build();
          }
        }
     }
     return getUpdateGroupMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDisableGroupsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableGroupsRequest,
      com.google.android.overtheair.v1.DisableGroupsResponse> METHOD_DISABLE_GROUPS = getDisableGroupsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableGroupsRequest,
      com.google.android.overtheair.v1.DisableGroupsResponse> getDisableGroupsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableGroupsRequest,
      com.google.android.overtheair.v1.DisableGroupsResponse> getDisableGroupsMethod() {
    return getDisableGroupsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableGroupsRequest,
      com.google.android.overtheair.v1.DisableGroupsResponse> getDisableGroupsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableGroupsRequest, com.google.android.overtheair.v1.DisableGroupsResponse> getDisableGroupsMethod;
    if ((getDisableGroupsMethod = OverTheAirServiceGrpc.getDisableGroupsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDisableGroupsMethod = OverTheAirServiceGrpc.getDisableGroupsMethod) == null) {
          OverTheAirServiceGrpc.getDisableGroupsMethod = getDisableGroupsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DisableGroupsRequest, com.google.android.overtheair.v1.DisableGroupsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DisableGroups"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DisableGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DisableGroupsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DisableGroups"))
                  .build();
          }
        }
     }
     return getDisableGroupsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getEnableGroupsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.EnableGroupsRequest,
      com.google.android.overtheair.v1.EnableGroupsResponse> METHOD_ENABLE_GROUPS = getEnableGroupsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.EnableGroupsRequest,
      com.google.android.overtheair.v1.EnableGroupsResponse> getEnableGroupsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.EnableGroupsRequest,
      com.google.android.overtheair.v1.EnableGroupsResponse> getEnableGroupsMethod() {
    return getEnableGroupsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.EnableGroupsRequest,
      com.google.android.overtheair.v1.EnableGroupsResponse> getEnableGroupsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.EnableGroupsRequest, com.google.android.overtheair.v1.EnableGroupsResponse> getEnableGroupsMethod;
    if ((getEnableGroupsMethod = OverTheAirServiceGrpc.getEnableGroupsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getEnableGroupsMethod = OverTheAirServiceGrpc.getEnableGroupsMethod) == null) {
          OverTheAirServiceGrpc.getEnableGroupsMethod = getEnableGroupsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.EnableGroupsRequest, com.google.android.overtheair.v1.EnableGroupsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "EnableGroups"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.EnableGroupsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.EnableGroupsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("EnableGroups"))
                  .build();
          }
        }
     }
     return getEnableGroupsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getCreateGroupMemberMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> METHOD_CREATE_GROUP_MEMBER = getCreateGroupMemberMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getCreateGroupMemberMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getCreateGroupMemberMethod() {
    return getCreateGroupMemberMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getCreateGroupMemberMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMemberRequest, com.google.android.overtheair.v1.GroupMember> getCreateGroupMemberMethod;
    if ((getCreateGroupMemberMethod = OverTheAirServiceGrpc.getCreateGroupMemberMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getCreateGroupMemberMethod = OverTheAirServiceGrpc.getCreateGroupMemberMethod) == null) {
          OverTheAirServiceGrpc.getCreateGroupMemberMethod = getCreateGroupMemberMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.CreateGroupMemberRequest, com.google.android.overtheair.v1.GroupMember>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "CreateGroupMember"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.CreateGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GroupMember.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("CreateGroupMember"))
                  .build();
          }
        }
     }
     return getCreateGroupMemberMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getCreateGroupMembersMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMembersRequest,
      com.google.android.overtheair.v1.CreateGroupMembersResponse> METHOD_CREATE_GROUP_MEMBERS = getCreateGroupMembersMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMembersRequest,
      com.google.android.overtheair.v1.CreateGroupMembersResponse> getCreateGroupMembersMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMembersRequest,
      com.google.android.overtheair.v1.CreateGroupMembersResponse> getCreateGroupMembersMethod() {
    return getCreateGroupMembersMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMembersRequest,
      com.google.android.overtheair.v1.CreateGroupMembersResponse> getCreateGroupMembersMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.CreateGroupMembersRequest, com.google.android.overtheair.v1.CreateGroupMembersResponse> getCreateGroupMembersMethod;
    if ((getCreateGroupMembersMethod = OverTheAirServiceGrpc.getCreateGroupMembersMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getCreateGroupMembersMethod = OverTheAirServiceGrpc.getCreateGroupMembersMethod) == null) {
          OverTheAirServiceGrpc.getCreateGroupMembersMethod = getCreateGroupMembersMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.CreateGroupMembersRequest, com.google.android.overtheair.v1.CreateGroupMembersResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "CreateGroupMembers"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.CreateGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.CreateGroupMembersResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("CreateGroupMembers"))
                  .build();
          }
        }
     }
     return getCreateGroupMembersMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetGroupMemberMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> METHOD_GET_GROUP_MEMBER = getGetGroupMemberMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getGetGroupMemberMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getGetGroupMemberMethod() {
    return getGetGroupMemberMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupMemberRequest,
      com.google.android.overtheair.v1.GroupMember> getGetGroupMemberMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupMemberRequest, com.google.android.overtheair.v1.GroupMember> getGetGroupMemberMethod;
    if ((getGetGroupMemberMethod = OverTheAirServiceGrpc.getGetGroupMemberMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetGroupMemberMethod = OverTheAirServiceGrpc.getGetGroupMemberMethod) == null) {
          OverTheAirServiceGrpc.getGetGroupMemberMethod = getGetGroupMemberMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetGroupMemberRequest, com.google.android.overtheair.v1.GroupMember>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetGroupMember"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GroupMember.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetGroupMember"))
                  .build();
          }
        }
     }
     return getGetGroupMemberMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListGroupMembersMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupMembersRequest,
      com.google.android.overtheair.v1.ListGroupMembersResponse> METHOD_LIST_GROUP_MEMBERS = getListGroupMembersMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupMembersRequest,
      com.google.android.overtheair.v1.ListGroupMembersResponse> getListGroupMembersMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupMembersRequest,
      com.google.android.overtheair.v1.ListGroupMembersResponse> getListGroupMembersMethod() {
    return getListGroupMembersMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupMembersRequest,
      com.google.android.overtheair.v1.ListGroupMembersResponse> getListGroupMembersMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupMembersRequest, com.google.android.overtheair.v1.ListGroupMembersResponse> getListGroupMembersMethod;
    if ((getListGroupMembersMethod = OverTheAirServiceGrpc.getListGroupMembersMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListGroupMembersMethod = OverTheAirServiceGrpc.getListGroupMembersMethod) == null) {
          OverTheAirServiceGrpc.getListGroupMembersMethod = getListGroupMembersMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListGroupMembersRequest, com.google.android.overtheair.v1.ListGroupMembersResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListGroupMembers"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupMembersResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListGroupMembers"))
                  .build();
          }
        }
     }
     return getListGroupMembersMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDeleteGroupMemberMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMemberRequest,
      com.google.android.overtheair.v1.DeleteGroupMemberResponse> METHOD_DELETE_GROUP_MEMBER = getDeleteGroupMemberMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMemberRequest,
      com.google.android.overtheair.v1.DeleteGroupMemberResponse> getDeleteGroupMemberMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMemberRequest,
      com.google.android.overtheair.v1.DeleteGroupMemberResponse> getDeleteGroupMemberMethod() {
    return getDeleteGroupMemberMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMemberRequest,
      com.google.android.overtheair.v1.DeleteGroupMemberResponse> getDeleteGroupMemberMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMemberRequest, com.google.android.overtheair.v1.DeleteGroupMemberResponse> getDeleteGroupMemberMethod;
    if ((getDeleteGroupMemberMethod = OverTheAirServiceGrpc.getDeleteGroupMemberMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDeleteGroupMemberMethod = OverTheAirServiceGrpc.getDeleteGroupMemberMethod) == null) {
          OverTheAirServiceGrpc.getDeleteGroupMemberMethod = getDeleteGroupMemberMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DeleteGroupMemberRequest, com.google.android.overtheair.v1.DeleteGroupMemberResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DeleteGroupMember"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupMemberRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupMemberResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DeleteGroupMember"))
                  .build();
          }
        }
     }
     return getDeleteGroupMemberMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDeleteGroupMembersMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMembersRequest,
      com.google.android.overtheair.v1.DeleteGroupMembersResponse> METHOD_DELETE_GROUP_MEMBERS = getDeleteGroupMembersMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMembersRequest,
      com.google.android.overtheair.v1.DeleteGroupMembersResponse> getDeleteGroupMembersMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMembersRequest,
      com.google.android.overtheair.v1.DeleteGroupMembersResponse> getDeleteGroupMembersMethod() {
    return getDeleteGroupMembersMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMembersRequest,
      com.google.android.overtheair.v1.DeleteGroupMembersResponse> getDeleteGroupMembersMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DeleteGroupMembersRequest, com.google.android.overtheair.v1.DeleteGroupMembersResponse> getDeleteGroupMembersMethod;
    if ((getDeleteGroupMembersMethod = OverTheAirServiceGrpc.getDeleteGroupMembersMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDeleteGroupMembersMethod = OverTheAirServiceGrpc.getDeleteGroupMembersMethod) == null) {
          OverTheAirServiceGrpc.getDeleteGroupMembersMethod = getDeleteGroupMembersMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DeleteGroupMembersRequest, com.google.android.overtheair.v1.DeleteGroupMembersResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DeleteGroupMembers"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupMembersRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DeleteGroupMembersResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DeleteGroupMembers"))
                  .build();
          }
        }
     }
     return getDeleteGroupMembersMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getGetGroupChartMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupChartRequest,
      com.google.android.overtheair.v1.Chart> METHOD_GET_GROUP_CHART = getGetGroupChartMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupChartRequest,
      com.google.android.overtheair.v1.Chart> getGetGroupChartMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupChartRequest,
      com.google.android.overtheair.v1.Chart> getGetGroupChartMethod() {
    return getGetGroupChartMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupChartRequest,
      com.google.android.overtheair.v1.Chart> getGetGroupChartMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.GetGroupChartRequest, com.google.android.overtheair.v1.Chart> getGetGroupChartMethod;
    if ((getGetGroupChartMethod = OverTheAirServiceGrpc.getGetGroupChartMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getGetGroupChartMethod = OverTheAirServiceGrpc.getGetGroupChartMethod) == null) {
          OverTheAirServiceGrpc.getGetGroupChartMethod = getGetGroupChartMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.GetGroupChartRequest, com.google.android.overtheair.v1.Chart>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "GetGroupChart"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.GetGroupChartRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.Chart.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("GetGroupChart"))
                  .build();
          }
        }
     }
     return getGetGroupChartMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListGroupChartsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupChartsRequest,
      com.google.android.overtheair.v1.ListGroupChartsResponse> METHOD_LIST_GROUP_CHARTS = getListGroupChartsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupChartsRequest,
      com.google.android.overtheair.v1.ListGroupChartsResponse> getListGroupChartsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupChartsRequest,
      com.google.android.overtheair.v1.ListGroupChartsResponse> getListGroupChartsMethod() {
    return getListGroupChartsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupChartsRequest,
      com.google.android.overtheair.v1.ListGroupChartsResponse> getListGroupChartsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupChartsRequest, com.google.android.overtheair.v1.ListGroupChartsResponse> getListGroupChartsMethod;
    if ((getListGroupChartsMethod = OverTheAirServiceGrpc.getListGroupChartsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListGroupChartsMethod = OverTheAirServiceGrpc.getListGroupChartsMethod) == null) {
          OverTheAirServiceGrpc.getListGroupChartsMethod = getListGroupChartsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListGroupChartsRequest, com.google.android.overtheair.v1.ListGroupChartsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListGroupCharts"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupChartsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupChartsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListGroupCharts"))
                  .build();
          }
        }
     }
     return getListGroupChartsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListGroupConfigsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupConfigsRequest,
      com.google.android.overtheair.v1.ListGroupConfigsResponse> METHOD_LIST_GROUP_CONFIGS = getListGroupConfigsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupConfigsRequest,
      com.google.android.overtheair.v1.ListGroupConfigsResponse> getListGroupConfigsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupConfigsRequest,
      com.google.android.overtheair.v1.ListGroupConfigsResponse> getListGroupConfigsMethod() {
    return getListGroupConfigsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupConfigsRequest,
      com.google.android.overtheair.v1.ListGroupConfigsResponse> getListGroupConfigsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListGroupConfigsRequest, com.google.android.overtheair.v1.ListGroupConfigsResponse> getListGroupConfigsMethod;
    if ((getListGroupConfigsMethod = OverTheAirServiceGrpc.getListGroupConfigsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListGroupConfigsMethod = OverTheAirServiceGrpc.getListGroupConfigsMethod) == null) {
          OverTheAirServiceGrpc.getListGroupConfigsMethod = getListGroupConfigsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListGroupConfigsRequest, com.google.android.overtheair.v1.ListGroupConfigsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListGroupConfigs"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListGroupConfigsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListGroupConfigs"))
                  .build();
          }
        }
     }
     return getListGroupConfigsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdateGroupConfigsMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupConfigsRequest,
      com.google.android.overtheair.v1.UpdateGroupConfigsResponse> METHOD_UPDATE_GROUP_CONFIGS = getUpdateGroupConfigsMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupConfigsRequest,
      com.google.android.overtheair.v1.UpdateGroupConfigsResponse> getUpdateGroupConfigsMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupConfigsRequest,
      com.google.android.overtheair.v1.UpdateGroupConfigsResponse> getUpdateGroupConfigsMethod() {
    return getUpdateGroupConfigsMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupConfigsRequest,
      com.google.android.overtheair.v1.UpdateGroupConfigsResponse> getUpdateGroupConfigsMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateGroupConfigsRequest, com.google.android.overtheair.v1.UpdateGroupConfigsResponse> getUpdateGroupConfigsMethod;
    if ((getUpdateGroupConfigsMethod = OverTheAirServiceGrpc.getUpdateGroupConfigsMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdateGroupConfigsMethod = OverTheAirServiceGrpc.getUpdateGroupConfigsMethod) == null) {
          OverTheAirServiceGrpc.getUpdateGroupConfigsMethod = getUpdateGroupConfigsMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdateGroupConfigsRequest, com.google.android.overtheair.v1.UpdateGroupConfigsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdateGroupConfigs"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateGroupConfigsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateGroupConfigsResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdateGroupConfigs"))
                  .build();
          }
        }
     }
     return getUpdateGroupConfigsMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getDisableAllEnabledGroupsOfConfigMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest,
      com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> METHOD_DISABLE_ALL_ENABLED_GROUPS_OF_CONFIG = getDisableAllEnabledGroupsOfConfigMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest,
      com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> getDisableAllEnabledGroupsOfConfigMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest,
      com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> getDisableAllEnabledGroupsOfConfigMethod() {
    return getDisableAllEnabledGroupsOfConfigMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest,
      com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> getDisableAllEnabledGroupsOfConfigMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest, com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> getDisableAllEnabledGroupsOfConfigMethod;
    if ((getDisableAllEnabledGroupsOfConfigMethod = OverTheAirServiceGrpc.getDisableAllEnabledGroupsOfConfigMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getDisableAllEnabledGroupsOfConfigMethod = OverTheAirServiceGrpc.getDisableAllEnabledGroupsOfConfigMethod) == null) {
          OverTheAirServiceGrpc.getDisableAllEnabledGroupsOfConfigMethod = getDisableAllEnabledGroupsOfConfigMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest, com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "DisableAllEnabledGroupsOfConfig"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("DisableAllEnabledGroupsOfConfig"))
                  .build();
          }
        }
     }
     return getDisableAllEnabledGroupsOfConfigMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListConfigPackagesMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigPackagesRequest,
      com.google.android.overtheair.v1.ListConfigPackagesResponse> METHOD_LIST_CONFIG_PACKAGES = getListConfigPackagesMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigPackagesRequest,
      com.google.android.overtheair.v1.ListConfigPackagesResponse> getListConfigPackagesMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigPackagesRequest,
      com.google.android.overtheair.v1.ListConfigPackagesResponse> getListConfigPackagesMethod() {
    return getListConfigPackagesMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigPackagesRequest,
      com.google.android.overtheair.v1.ListConfigPackagesResponse> getListConfigPackagesMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigPackagesRequest, com.google.android.overtheair.v1.ListConfigPackagesResponse> getListConfigPackagesMethod;
    if ((getListConfigPackagesMethod = OverTheAirServiceGrpc.getListConfigPackagesMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListConfigPackagesMethod = OverTheAirServiceGrpc.getListConfigPackagesMethod) == null) {
          OverTheAirServiceGrpc.getListConfigPackagesMethod = getListConfigPackagesMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListConfigPackagesRequest, com.google.android.overtheair.v1.ListConfigPackagesResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListConfigPackages"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigPackagesResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListConfigPackages"))
                  .build();
          }
        }
     }
     return getListConfigPackagesMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getUpdateConfigPackagesMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigPackagesRequest,
      com.google.android.overtheair.v1.UpdateConfigPackagesResponse> METHOD_UPDATE_CONFIG_PACKAGES = getUpdateConfigPackagesMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigPackagesRequest,
      com.google.android.overtheair.v1.UpdateConfigPackagesResponse> getUpdateConfigPackagesMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigPackagesRequest,
      com.google.android.overtheair.v1.UpdateConfigPackagesResponse> getUpdateConfigPackagesMethod() {
    return getUpdateConfigPackagesMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigPackagesRequest,
      com.google.android.overtheair.v1.UpdateConfigPackagesResponse> getUpdateConfigPackagesMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.UpdateConfigPackagesRequest, com.google.android.overtheair.v1.UpdateConfigPackagesResponse> getUpdateConfigPackagesMethod;
    if ((getUpdateConfigPackagesMethod = OverTheAirServiceGrpc.getUpdateConfigPackagesMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getUpdateConfigPackagesMethod = OverTheAirServiceGrpc.getUpdateConfigPackagesMethod) == null) {
          OverTheAirServiceGrpc.getUpdateConfigPackagesMethod = getUpdateConfigPackagesMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.UpdateConfigPackagesRequest, com.google.android.overtheair.v1.UpdateConfigPackagesResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "UpdateConfigPackages"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateConfigPackagesRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.UpdateConfigPackagesResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("UpdateConfigPackages"))
                  .build();
          }
        }
     }
     return getUpdateConfigPackagesMethod;
  }
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  @java.lang.Deprecated // Use {@link #getListConfigsUsingPackageMethod()} instead. 
  public static final io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest,
      com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> METHOD_LIST_CONFIGS_USING_PACKAGE = getListConfigsUsingPackageMethodHelper();

  private static volatile io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest,
      com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> getListConfigsUsingPackageMethod;

  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest,
      com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> getListConfigsUsingPackageMethod() {
    return getListConfigsUsingPackageMethodHelper();
  }

  private static io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest,
      com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> getListConfigsUsingPackageMethodHelper() {
    io.grpc.MethodDescriptor<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest, com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> getListConfigsUsingPackageMethod;
    if ((getListConfigsUsingPackageMethod = OverTheAirServiceGrpc.getListConfigsUsingPackageMethod) == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        if ((getListConfigsUsingPackageMethod = OverTheAirServiceGrpc.getListConfigsUsingPackageMethod) == null) {
          OverTheAirServiceGrpc.getListConfigsUsingPackageMethod = getListConfigsUsingPackageMethod = 
              io.grpc.MethodDescriptor.<com.google.android.overtheair.v1.ListConfigsUsingPackageRequest, com.google.android.overtheair.v1.ListConfigsUsingPackageResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(
                  "google.android.overtheair.v1.OverTheAirService", "ListConfigsUsingPackage"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigsUsingPackageRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.google.android.overtheair.v1.ListConfigsUsingPackageResponse.getDefaultInstance()))
                  .setSchemaDescriptor(new OverTheAirServiceMethodDescriptorSupplier("ListConfigsUsingPackage"))
                  .build();
          }
        }
     }
     return getListConfigsUsingPackageMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static OverTheAirServiceStub newStub(io.grpc.Channel channel) {
    return new OverTheAirServiceStub(channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static OverTheAirServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    return new OverTheAirServiceBlockingStub(channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static OverTheAirServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    return new OverTheAirServiceFutureStub(channel);
  }

  /**
   * <pre>
   * ## Service for Android Over the Air(OTA).
   * ## ----  deployment related rpcs              ---
   * </pre>
   */
  public static abstract class OverTheAirServiceImplBase implements io.grpc.BindableService {

    /**
     * <pre>
     * Gets a [Deployment][google.android.overtheair.v1.Deployment].
     * Returns `NOT_FOUND` if the deployment does not exist.
     * </pre>
     */
    public void getDeployment(com.google.android.overtheair.v1.GetDeploymentRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment> responseObserver) {
      asyncUnimplementedUnaryCall(getGetDeploymentMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [deployments][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public void listDeployments(com.google.android.overtheair.v1.ListDeploymentsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListDeploymentsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListDeploymentsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Updates a [deployment][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public void updateDeployment(com.google.android.overtheair.v1.UpdateDeploymentRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdateDeploymentMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Gets a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getPackage(com.google.android.overtheair.v1.GetPackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package> responseObserver) {
      asyncUnimplementedUnaryCall(getGetPackageMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [packages][google.android.overtheair.v1.Package].
     * </pre>
     */
    public void listPackages(com.google.android.overtheair.v1.ListPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListPackagesResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListPackagesMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Deletes a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deletePackage(com.google.android.overtheair.v1.DeletePackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeletePackageResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDeletePackageMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Updates a [package][google.android.overtheair.v1.Package].
     * Returns `INVALID_ARGUMENT` if any field other than title is modified.
     * </pre>
     */
    public void updatePackage(com.google.android.overtheair.v1.UpdatePackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdatePackageMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Creates a config, and returns the new
     * [Config][google.android.overtheair.v1.Config].
     * </pre>
     */
    public void createConfig(com.google.android.overtheair.v1.CreateConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateConfigMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Gets a [config][google.android.overtheair.v1.Config] view.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getConfig(com.google.android.overtheair.v1.GetConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnimplementedUnaryCall(getGetConfigMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [configs][google.android.overtheair.v1.Config] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listConfigs(com.google.android.overtheair.v1.ListConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListConfigsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Deletes a [config][google.android.overtheair.v1.Config].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deleteConfig(com.google.android.overtheair.v1.DeleteConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteConfigResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDeleteConfigMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Updates a [config][google.android.overtheair.v1.Config].
     * Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public void updateConfig(com.google.android.overtheair.v1.UpdateConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdateConfigMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Creates a group, and returns the new
     * [Group][google.android.overtheair.v1.Group].
     * </pre>
     */
    public void createGroup(com.google.android.overtheair.v1.CreateGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateGroupMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Gets a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public void getGroup(com.google.android.overtheair.v1.GetGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnimplementedUnaryCall(getGetGroupMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [groups][google.android.overtheair.v1.Group] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroups(com.google.android.overtheair.v1.ListGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListGroupsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Deletes a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public void deleteGroup(com.google.android.overtheair.v1.DeleteGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDeleteGroupMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Updates a [group][google.android.overtheair.v1.Group].
     * Returns INVALID_ARGUMENT if the name of the group is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public void updateGroup(com.google.android.overtheair.v1.UpdateGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdateGroupMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Disables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void disableGroups(com.google.android.overtheair.v1.DisableGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableGroupsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDisableGroupsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Enables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void enableGroups(com.google.android.overtheair.v1.EnableGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.EnableGroupsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getEnableGroupsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Creates a group member and returns the new
     * [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
     * already under other groups, it will be removed from those groups and added
     * to the group that's specified in the request.
     * </pre>
     */
    public void createGroupMember(com.google.android.overtheair.v1.CreateGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateGroupMemberMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Creates group members in a specific group.  If any device is in other
     * groups, it will be removed from those groups and added to the group that's
     * specified in the request.
     * </pre>
     */
    public void createGroupMembers(com.google.android.overtheair.v1.CreateGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.CreateGroupMembersResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCreateGroupMembersMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Gets a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getGroupMember(com.google.android.overtheair.v1.GetGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember> responseObserver) {
      asyncUnimplementedUnaryCall(getGetGroupMemberMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [group members][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroupMembers(com.google.android.overtheair.v1.ListGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupMembersResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListGroupMembersMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Deletes a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deleteGroupMember(com.google.android.overtheair.v1.DeleteGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMemberResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDeleteGroupMemberMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Deletes group members in a group.  If any member does not it exist, it
     * will be ignored.
     * </pre>
     */
    public void deleteGroupMembers(com.google.android.overtheair.v1.DeleteGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMembersResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDeleteGroupMembersMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Gets a [group chart][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getGroupChart(com.google.android.overtheair.v1.GetGroupChartRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Chart> responseObserver) {
      asyncUnimplementedUnaryCall(getGetGroupChartMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists [group charts][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroupCharts(com.google.android.overtheair.v1.ListGroupChartsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupChartsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListGroupChartsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists configs of the group. Returns `NOT_FOUND` if the matching path
     * does not exist.
     * </pre>
     */
    public void listGroupConfigs(com.google.android.overtheair.v1.ListGroupConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupConfigsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListGroupConfigsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Update the configs under a group. Returns `NOT_FOUND` if the matching group
     * or config does not exist.
     * </pre>
     */
    public void updateGroupConfigs(com.google.android.overtheair.v1.UpdateGroupConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateGroupConfigsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdateGroupConfigsMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Disables all enabled groups that have the specified config.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void disableAllEnabledGroupsOfConfig(com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getDisableAllEnabledGroupsOfConfigMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists packages of the config. Returns `NOT_FOUND` if the matching path does
     * not exist.
     * </pre>
     */
    public void listConfigPackages(com.google.android.overtheair.v1.ListConfigPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigPackagesResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListConfigPackagesMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Update the packages under the config. Returns `NOT_FOUND` if the matching
     * path does not exist.
     * </pre>
     */
    public void updateConfigPackages(com.google.android.overtheair.v1.UpdateConfigPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateConfigPackagesResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getUpdateConfigPackagesMethodHelper(), responseObserver);
    }

    /**
     * <pre>
     * Lists all the configs that use the specified package.
     * </pre>
     */
    public void listConfigsUsingPackage(com.google.android.overtheair.v1.ListConfigsUsingPackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getListConfigsUsingPackageMethodHelper(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetDeploymentMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetDeploymentRequest,
                com.google.android.overtheair.v1.Deployment>(
                  this, METHODID_GET_DEPLOYMENT)))
          .addMethod(
            getListDeploymentsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListDeploymentsRequest,
                com.google.android.overtheair.v1.ListDeploymentsResponse>(
                  this, METHODID_LIST_DEPLOYMENTS)))
          .addMethod(
            getUpdateDeploymentMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdateDeploymentRequest,
                com.google.android.overtheair.v1.Deployment>(
                  this, METHODID_UPDATE_DEPLOYMENT)))
          .addMethod(
            getGetPackageMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetPackageRequest,
                com.google.android.overtheair.v1.Package>(
                  this, METHODID_GET_PACKAGE)))
          .addMethod(
            getListPackagesMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListPackagesRequest,
                com.google.android.overtheair.v1.ListPackagesResponse>(
                  this, METHODID_LIST_PACKAGES)))
          .addMethod(
            getDeletePackageMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DeletePackageRequest,
                com.google.android.overtheair.v1.DeletePackageResponse>(
                  this, METHODID_DELETE_PACKAGE)))
          .addMethod(
            getUpdatePackageMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdatePackageRequest,
                com.google.android.overtheair.v1.Package>(
                  this, METHODID_UPDATE_PACKAGE)))
          .addMethod(
            getCreateConfigMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.CreateConfigRequest,
                com.google.android.overtheair.v1.Config>(
                  this, METHODID_CREATE_CONFIG)))
          .addMethod(
            getGetConfigMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetConfigRequest,
                com.google.android.overtheair.v1.Config>(
                  this, METHODID_GET_CONFIG)))
          .addMethod(
            getListConfigsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListConfigsRequest,
                com.google.android.overtheair.v1.ListConfigsResponse>(
                  this, METHODID_LIST_CONFIGS)))
          .addMethod(
            getDeleteConfigMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DeleteConfigRequest,
                com.google.android.overtheair.v1.DeleteConfigResponse>(
                  this, METHODID_DELETE_CONFIG)))
          .addMethod(
            getUpdateConfigMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdateConfigRequest,
                com.google.android.overtheair.v1.Config>(
                  this, METHODID_UPDATE_CONFIG)))
          .addMethod(
            getCreateGroupMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.CreateGroupRequest,
                com.google.android.overtheair.v1.Group>(
                  this, METHODID_CREATE_GROUP)))
          .addMethod(
            getGetGroupMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetGroupRequest,
                com.google.android.overtheair.v1.Group>(
                  this, METHODID_GET_GROUP)))
          .addMethod(
            getListGroupsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListGroupsRequest,
                com.google.android.overtheair.v1.ListGroupsResponse>(
                  this, METHODID_LIST_GROUPS)))
          .addMethod(
            getDeleteGroupMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DeleteGroupRequest,
                com.google.android.overtheair.v1.DeleteGroupResponse>(
                  this, METHODID_DELETE_GROUP)))
          .addMethod(
            getUpdateGroupMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdateGroupRequest,
                com.google.android.overtheair.v1.Group>(
                  this, METHODID_UPDATE_GROUP)))
          .addMethod(
            getDisableGroupsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DisableGroupsRequest,
                com.google.android.overtheair.v1.DisableGroupsResponse>(
                  this, METHODID_DISABLE_GROUPS)))
          .addMethod(
            getEnableGroupsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.EnableGroupsRequest,
                com.google.android.overtheair.v1.EnableGroupsResponse>(
                  this, METHODID_ENABLE_GROUPS)))
          .addMethod(
            getCreateGroupMemberMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.CreateGroupMemberRequest,
                com.google.android.overtheair.v1.GroupMember>(
                  this, METHODID_CREATE_GROUP_MEMBER)))
          .addMethod(
            getCreateGroupMembersMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.CreateGroupMembersRequest,
                com.google.android.overtheair.v1.CreateGroupMembersResponse>(
                  this, METHODID_CREATE_GROUP_MEMBERS)))
          .addMethod(
            getGetGroupMemberMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetGroupMemberRequest,
                com.google.android.overtheair.v1.GroupMember>(
                  this, METHODID_GET_GROUP_MEMBER)))
          .addMethod(
            getListGroupMembersMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListGroupMembersRequest,
                com.google.android.overtheair.v1.ListGroupMembersResponse>(
                  this, METHODID_LIST_GROUP_MEMBERS)))
          .addMethod(
            getDeleteGroupMemberMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DeleteGroupMemberRequest,
                com.google.android.overtheair.v1.DeleteGroupMemberResponse>(
                  this, METHODID_DELETE_GROUP_MEMBER)))
          .addMethod(
            getDeleteGroupMembersMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DeleteGroupMembersRequest,
                com.google.android.overtheair.v1.DeleteGroupMembersResponse>(
                  this, METHODID_DELETE_GROUP_MEMBERS)))
          .addMethod(
            getGetGroupChartMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.GetGroupChartRequest,
                com.google.android.overtheair.v1.Chart>(
                  this, METHODID_GET_GROUP_CHART)))
          .addMethod(
            getListGroupChartsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListGroupChartsRequest,
                com.google.android.overtheair.v1.ListGroupChartsResponse>(
                  this, METHODID_LIST_GROUP_CHARTS)))
          .addMethod(
            getListGroupConfigsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListGroupConfigsRequest,
                com.google.android.overtheair.v1.ListGroupConfigsResponse>(
                  this, METHODID_LIST_GROUP_CONFIGS)))
          .addMethod(
            getUpdateGroupConfigsMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdateGroupConfigsRequest,
                com.google.android.overtheair.v1.UpdateGroupConfigsResponse>(
                  this, METHODID_UPDATE_GROUP_CONFIGS)))
          .addMethod(
            getDisableAllEnabledGroupsOfConfigMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest,
                com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse>(
                  this, METHODID_DISABLE_ALL_ENABLED_GROUPS_OF_CONFIG)))
          .addMethod(
            getListConfigPackagesMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListConfigPackagesRequest,
                com.google.android.overtheair.v1.ListConfigPackagesResponse>(
                  this, METHODID_LIST_CONFIG_PACKAGES)))
          .addMethod(
            getUpdateConfigPackagesMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.UpdateConfigPackagesRequest,
                com.google.android.overtheair.v1.UpdateConfigPackagesResponse>(
                  this, METHODID_UPDATE_CONFIG_PACKAGES)))
          .addMethod(
            getListConfigsUsingPackageMethodHelper(),
            asyncUnaryCall(
              new MethodHandlers<
                com.google.android.overtheair.v1.ListConfigsUsingPackageRequest,
                com.google.android.overtheair.v1.ListConfigsUsingPackageResponse>(
                  this, METHODID_LIST_CONFIGS_USING_PACKAGE)))
          .build();
    }
  }

  /**
   * <pre>
   * ## Service for Android Over the Air(OTA).
   * ## ----  deployment related rpcs              ---
   * </pre>
   */
  public static final class OverTheAirServiceStub extends io.grpc.stub.AbstractStub<OverTheAirServiceStub> {
    private OverTheAirServiceStub(io.grpc.Channel channel) {
      super(channel);
    }

    private OverTheAirServiceStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected OverTheAirServiceStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new OverTheAirServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * Gets a [Deployment][google.android.overtheair.v1.Deployment].
     * Returns `NOT_FOUND` if the deployment does not exist.
     * </pre>
     */
    public void getDeployment(com.google.android.overtheair.v1.GetDeploymentRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetDeploymentMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [deployments][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public void listDeployments(com.google.android.overtheair.v1.ListDeploymentsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListDeploymentsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListDeploymentsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Updates a [deployment][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public void updateDeployment(com.google.android.overtheair.v1.UpdateDeploymentRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdateDeploymentMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Gets a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getPackage(com.google.android.overtheair.v1.GetPackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetPackageMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [packages][google.android.overtheair.v1.Package].
     * </pre>
     */
    public void listPackages(com.google.android.overtheair.v1.ListPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListPackagesResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListPackagesMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Deletes a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deletePackage(com.google.android.overtheair.v1.DeletePackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeletePackageResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDeletePackageMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Updates a [package][google.android.overtheair.v1.Package].
     * Returns `INVALID_ARGUMENT` if any field other than title is modified.
     * </pre>
     */
    public void updatePackage(com.google.android.overtheair.v1.UpdatePackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdatePackageMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Creates a config, and returns the new
     * [Config][google.android.overtheair.v1.Config].
     * </pre>
     */
    public void createConfig(com.google.android.overtheair.v1.CreateConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateConfigMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Gets a [config][google.android.overtheair.v1.Config] view.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getConfig(com.google.android.overtheair.v1.GetConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetConfigMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [configs][google.android.overtheair.v1.Config] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listConfigs(com.google.android.overtheair.v1.ListConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListConfigsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Deletes a [config][google.android.overtheair.v1.Config].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deleteConfig(com.google.android.overtheair.v1.DeleteConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteConfigResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDeleteConfigMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Updates a [config][google.android.overtheair.v1.Config].
     * Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public void updateConfig(com.google.android.overtheair.v1.UpdateConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdateConfigMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Creates a group, and returns the new
     * [Group][google.android.overtheair.v1.Group].
     * </pre>
     */
    public void createGroup(com.google.android.overtheair.v1.CreateGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateGroupMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Gets a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public void getGroup(com.google.android.overtheair.v1.GetGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetGroupMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [groups][google.android.overtheair.v1.Group] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroups(com.google.android.overtheair.v1.ListGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListGroupsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Deletes a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public void deleteGroup(com.google.android.overtheair.v1.DeleteGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDeleteGroupMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Updates a [group][google.android.overtheair.v1.Group].
     * Returns INVALID_ARGUMENT if the name of the group is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public void updateGroup(com.google.android.overtheair.v1.UpdateGroupRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdateGroupMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Disables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void disableGroups(com.google.android.overtheair.v1.DisableGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableGroupsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDisableGroupsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Enables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void enableGroups(com.google.android.overtheair.v1.EnableGroupsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.EnableGroupsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getEnableGroupsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Creates a group member and returns the new
     * [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
     * already under other groups, it will be removed from those groups and added
     * to the group that's specified in the request.
     * </pre>
     */
    public void createGroupMember(com.google.android.overtheair.v1.CreateGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateGroupMemberMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Creates group members in a specific group.  If any device is in other
     * groups, it will be removed from those groups and added to the group that's
     * specified in the request.
     * </pre>
     */
    public void createGroupMembers(com.google.android.overtheair.v1.CreateGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.CreateGroupMembersResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCreateGroupMembersMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Gets a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getGroupMember(com.google.android.overtheair.v1.GetGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetGroupMemberMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [group members][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroupMembers(com.google.android.overtheair.v1.ListGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupMembersResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListGroupMembersMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Deletes a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void deleteGroupMember(com.google.android.overtheair.v1.DeleteGroupMemberRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMemberResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDeleteGroupMemberMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Deletes group members in a group.  If any member does not it exist, it
     * will be ignored.
     * </pre>
     */
    public void deleteGroupMembers(com.google.android.overtheair.v1.DeleteGroupMembersRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMembersResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDeleteGroupMembersMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Gets a [group chart][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void getGroupChart(com.google.android.overtheair.v1.GetGroupChartRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Chart> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetGroupChartMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists [group charts][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void listGroupCharts(com.google.android.overtheair.v1.ListGroupChartsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupChartsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListGroupChartsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists configs of the group. Returns `NOT_FOUND` if the matching path
     * does not exist.
     * </pre>
     */
    public void listGroupConfigs(com.google.android.overtheair.v1.ListGroupConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupConfigsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListGroupConfigsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Update the configs under a group. Returns `NOT_FOUND` if the matching group
     * or config does not exist.
     * </pre>
     */
    public void updateGroupConfigs(com.google.android.overtheair.v1.UpdateGroupConfigsRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateGroupConfigsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdateGroupConfigsMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Disables all enabled groups that have the specified config.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public void disableAllEnabledGroupsOfConfig(com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getDisableAllEnabledGroupsOfConfigMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists packages of the config. Returns `NOT_FOUND` if the matching path does
     * not exist.
     * </pre>
     */
    public void listConfigPackages(com.google.android.overtheair.v1.ListConfigPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigPackagesResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListConfigPackagesMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Update the packages under the config. Returns `NOT_FOUND` if the matching
     * path does not exist.
     * </pre>
     */
    public void updateConfigPackages(com.google.android.overtheair.v1.UpdateConfigPackagesRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateConfigPackagesResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getUpdateConfigPackagesMethodHelper(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * Lists all the configs that use the specified package.
     * </pre>
     */
    public void listConfigsUsingPackage(com.google.android.overtheair.v1.ListConfigsUsingPackageRequest request,
        io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getListConfigsUsingPackageMethodHelper(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   * <pre>
   * ## Service for Android Over the Air(OTA).
   * ## ----  deployment related rpcs              ---
   * </pre>
   */
  public static final class OverTheAirServiceBlockingStub extends io.grpc.stub.AbstractStub<OverTheAirServiceBlockingStub> {
    private OverTheAirServiceBlockingStub(io.grpc.Channel channel) {
      super(channel);
    }

    private OverTheAirServiceBlockingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected OverTheAirServiceBlockingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new OverTheAirServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * Gets a [Deployment][google.android.overtheair.v1.Deployment].
     * Returns `NOT_FOUND` if the deployment does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.Deployment getDeployment(com.google.android.overtheair.v1.GetDeploymentRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetDeploymentMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [deployments][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public com.google.android.overtheair.v1.ListDeploymentsResponse listDeployments(com.google.android.overtheair.v1.ListDeploymentsRequest request) {
      return blockingUnaryCall(
          getChannel(), getListDeploymentsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Updates a [deployment][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public com.google.android.overtheair.v1.Deployment updateDeployment(com.google.android.overtheair.v1.UpdateDeploymentRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdateDeploymentMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Gets a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.Package getPackage(com.google.android.overtheair.v1.GetPackageRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetPackageMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [packages][google.android.overtheair.v1.Package].
     * </pre>
     */
    public com.google.android.overtheair.v1.ListPackagesResponse listPackages(com.google.android.overtheair.v1.ListPackagesRequest request) {
      return blockingUnaryCall(
          getChannel(), getListPackagesMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Deletes a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DeletePackageResponse deletePackage(com.google.android.overtheair.v1.DeletePackageRequest request) {
      return blockingUnaryCall(
          getChannel(), getDeletePackageMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Updates a [package][google.android.overtheair.v1.Package].
     * Returns `INVALID_ARGUMENT` if any field other than title is modified.
     * </pre>
     */
    public com.google.android.overtheair.v1.Package updatePackage(com.google.android.overtheair.v1.UpdatePackageRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdatePackageMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Creates a config, and returns the new
     * [Config][google.android.overtheair.v1.Config].
     * </pre>
     */
    public com.google.android.overtheair.v1.Config createConfig(com.google.android.overtheair.v1.CreateConfigRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateConfigMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Gets a [config][google.android.overtheair.v1.Config] view.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.Config getConfig(com.google.android.overtheair.v1.GetConfigRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetConfigMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [configs][google.android.overtheair.v1.Config] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListConfigsResponse listConfigs(com.google.android.overtheair.v1.ListConfigsRequest request) {
      return blockingUnaryCall(
          getChannel(), getListConfigsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Deletes a [config][google.android.overtheair.v1.Config].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DeleteConfigResponse deleteConfig(com.google.android.overtheair.v1.DeleteConfigRequest request) {
      return blockingUnaryCall(
          getChannel(), getDeleteConfigMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Updates a [config][google.android.overtheair.v1.Config].
     * Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public com.google.android.overtheair.v1.Config updateConfig(com.google.android.overtheair.v1.UpdateConfigRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdateConfigMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Creates a group, and returns the new
     * [Group][google.android.overtheair.v1.Group].
     * </pre>
     */
    public com.google.android.overtheair.v1.Group createGroup(com.google.android.overtheair.v1.CreateGroupRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateGroupMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Gets a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.Group getGroup(com.google.android.overtheair.v1.GetGroupRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetGroupMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [groups][google.android.overtheair.v1.Group] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListGroupsResponse listGroups(com.google.android.overtheair.v1.ListGroupsRequest request) {
      return blockingUnaryCall(
          getChannel(), getListGroupsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Deletes a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DeleteGroupResponse deleteGroup(com.google.android.overtheair.v1.DeleteGroupRequest request) {
      return blockingUnaryCall(
          getChannel(), getDeleteGroupMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Updates a [group][google.android.overtheair.v1.Group].
     * Returns INVALID_ARGUMENT if the name of the group is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public com.google.android.overtheair.v1.Group updateGroup(com.google.android.overtheair.v1.UpdateGroupRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdateGroupMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Disables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DisableGroupsResponse disableGroups(com.google.android.overtheair.v1.DisableGroupsRequest request) {
      return blockingUnaryCall(
          getChannel(), getDisableGroupsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Enables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.EnableGroupsResponse enableGroups(com.google.android.overtheair.v1.EnableGroupsRequest request) {
      return blockingUnaryCall(
          getChannel(), getEnableGroupsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Creates a group member and returns the new
     * [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
     * already under other groups, it will be removed from those groups and added
     * to the group that's specified in the request.
     * </pre>
     */
    public com.google.android.overtheair.v1.GroupMember createGroupMember(com.google.android.overtheair.v1.CreateGroupMemberRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateGroupMemberMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Creates group members in a specific group.  If any device is in other
     * groups, it will be removed from those groups and added to the group that's
     * specified in the request.
     * </pre>
     */
    public com.google.android.overtheair.v1.CreateGroupMembersResponse createGroupMembers(com.google.android.overtheair.v1.CreateGroupMembersRequest request) {
      return blockingUnaryCall(
          getChannel(), getCreateGroupMembersMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Gets a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.GroupMember getGroupMember(com.google.android.overtheair.v1.GetGroupMemberRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetGroupMemberMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [group members][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListGroupMembersResponse listGroupMembers(com.google.android.overtheair.v1.ListGroupMembersRequest request) {
      return blockingUnaryCall(
          getChannel(), getListGroupMembersMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Deletes a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DeleteGroupMemberResponse deleteGroupMember(com.google.android.overtheair.v1.DeleteGroupMemberRequest request) {
      return blockingUnaryCall(
          getChannel(), getDeleteGroupMemberMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Deletes group members in a group.  If any member does not it exist, it
     * will be ignored.
     * </pre>
     */
    public com.google.android.overtheair.v1.DeleteGroupMembersResponse deleteGroupMembers(com.google.android.overtheair.v1.DeleteGroupMembersRequest request) {
      return blockingUnaryCall(
          getChannel(), getDeleteGroupMembersMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Gets a [group chart][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.Chart getGroupChart(com.google.android.overtheair.v1.GetGroupChartRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetGroupChartMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists [group charts][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListGroupChartsResponse listGroupCharts(com.google.android.overtheair.v1.ListGroupChartsRequest request) {
      return blockingUnaryCall(
          getChannel(), getListGroupChartsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists configs of the group. Returns `NOT_FOUND` if the matching path
     * does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListGroupConfigsResponse listGroupConfigs(com.google.android.overtheair.v1.ListGroupConfigsRequest request) {
      return blockingUnaryCall(
          getChannel(), getListGroupConfigsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Update the configs under a group. Returns `NOT_FOUND` if the matching group
     * or config does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.UpdateGroupConfigsResponse updateGroupConfigs(com.google.android.overtheair.v1.UpdateGroupConfigsRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdateGroupConfigsMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Disables all enabled groups that have the specified config.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse disableAllEnabledGroupsOfConfig(com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest request) {
      return blockingUnaryCall(
          getChannel(), getDisableAllEnabledGroupsOfConfigMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists packages of the config. Returns `NOT_FOUND` if the matching path does
     * not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListConfigPackagesResponse listConfigPackages(com.google.android.overtheair.v1.ListConfigPackagesRequest request) {
      return blockingUnaryCall(
          getChannel(), getListConfigPackagesMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Update the packages under the config. Returns `NOT_FOUND` if the matching
     * path does not exist.
     * </pre>
     */
    public com.google.android.overtheair.v1.UpdateConfigPackagesResponse updateConfigPackages(com.google.android.overtheair.v1.UpdateConfigPackagesRequest request) {
      return blockingUnaryCall(
          getChannel(), getUpdateConfigPackagesMethodHelper(), getCallOptions(), request);
    }

    /**
     * <pre>
     * Lists all the configs that use the specified package.
     * </pre>
     */
    public com.google.android.overtheair.v1.ListConfigsUsingPackageResponse listConfigsUsingPackage(com.google.android.overtheair.v1.ListConfigsUsingPackageRequest request) {
      return blockingUnaryCall(
          getChannel(), getListConfigsUsingPackageMethodHelper(), getCallOptions(), request);
    }
  }

  /**
   * <pre>
   * ## Service for Android Over the Air(OTA).
   * ## ----  deployment related rpcs              ---
   * </pre>
   */
  public static final class OverTheAirServiceFutureStub extends io.grpc.stub.AbstractStub<OverTheAirServiceFutureStub> {
    private OverTheAirServiceFutureStub(io.grpc.Channel channel) {
      super(channel);
    }

    private OverTheAirServiceFutureStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected OverTheAirServiceFutureStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new OverTheAirServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * Gets a [Deployment][google.android.overtheair.v1.Deployment].
     * Returns `NOT_FOUND` if the deployment does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Deployment> getDeployment(
        com.google.android.overtheair.v1.GetDeploymentRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetDeploymentMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [deployments][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListDeploymentsResponse> listDeployments(
        com.google.android.overtheair.v1.ListDeploymentsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListDeploymentsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Updates a [deployment][google.android.overtheair.v1.Deployment].
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Deployment> updateDeployment(
        com.google.android.overtheair.v1.UpdateDeploymentRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdateDeploymentMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Gets a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Package> getPackage(
        com.google.android.overtheair.v1.GetPackageRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetPackageMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [packages][google.android.overtheair.v1.Package].
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListPackagesResponse> listPackages(
        com.google.android.overtheair.v1.ListPackagesRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListPackagesMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Deletes a [package][google.android.overtheair.v1.Package].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DeletePackageResponse> deletePackage(
        com.google.android.overtheair.v1.DeletePackageRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDeletePackageMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Updates a [package][google.android.overtheair.v1.Package].
     * Returns `INVALID_ARGUMENT` if any field other than title is modified.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Package> updatePackage(
        com.google.android.overtheair.v1.UpdatePackageRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdatePackageMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Creates a config, and returns the new
     * [Config][google.android.overtheair.v1.Config].
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Config> createConfig(
        com.google.android.overtheair.v1.CreateConfigRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateConfigMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Gets a [config][google.android.overtheair.v1.Config] view.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Config> getConfig(
        com.google.android.overtheair.v1.GetConfigRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetConfigMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [configs][google.android.overtheair.v1.Config] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListConfigsResponse> listConfigs(
        com.google.android.overtheair.v1.ListConfigsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListConfigsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Deletes a [config][google.android.overtheair.v1.Config].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DeleteConfigResponse> deleteConfig(
        com.google.android.overtheair.v1.DeleteConfigRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDeleteConfigMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Updates a [config][google.android.overtheair.v1.Config].
     * Returns `INVALID_ARGUMENT` if the name of the config is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Config> updateConfig(
        com.google.android.overtheair.v1.UpdateConfigRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdateConfigMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Creates a group, and returns the new
     * [Group][google.android.overtheair.v1.Group].
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Group> createGroup(
        com.google.android.overtheair.v1.CreateGroupRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateGroupMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Gets a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Group> getGroup(
        com.google.android.overtheair.v1.GetGroupRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetGroupMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [groups][google.android.overtheair.v1.Group] of a deployment.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListGroupsResponse> listGroups(
        com.google.android.overtheair.v1.ListGroupsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListGroupsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Deletes a [group][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the group does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DeleteGroupResponse> deleteGroup(
        com.google.android.overtheair.v1.DeleteGroupRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDeleteGroupMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Updates a [group][google.android.overtheair.v1.Group].
     * Returns INVALID_ARGUMENT if the name of the group is non-empty and does
     * not equal the existing name.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Group> updateGroup(
        com.google.android.overtheair.v1.UpdateGroupRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdateGroupMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Disables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DisableGroupsResponse> disableGroups(
        com.google.android.overtheair.v1.DisableGroupsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDisableGroupsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Enables the defined [groups][google.android.overtheair.v1.Group].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.EnableGroupsResponse> enableGroups(
        com.google.android.overtheair.v1.EnableGroupsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getEnableGroupsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Creates a group member and returns the new
     * [GroupMember][google.android.overtheair.v1.GroupMember]. If the device is
     * already under other groups, it will be removed from those groups and added
     * to the group that's specified in the request.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.GroupMember> createGroupMember(
        com.google.android.overtheair.v1.CreateGroupMemberRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateGroupMemberMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Creates group members in a specific group.  If any device is in other
     * groups, it will be removed from those groups and added to the group that's
     * specified in the request.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.CreateGroupMembersResponse> createGroupMembers(
        com.google.android.overtheair.v1.CreateGroupMembersRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCreateGroupMembersMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Gets a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.GroupMember> getGroupMember(
        com.google.android.overtheair.v1.GetGroupMemberRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetGroupMemberMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [group members][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListGroupMembersResponse> listGroupMembers(
        com.google.android.overtheair.v1.ListGroupMembersRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListGroupMembersMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Deletes a [group member][google.android.overtheair.v1.GroupMember].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DeleteGroupMemberResponse> deleteGroupMember(
        com.google.android.overtheair.v1.DeleteGroupMemberRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDeleteGroupMemberMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Deletes group members in a group.  If any member does not it exist, it
     * will be ignored.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DeleteGroupMembersResponse> deleteGroupMembers(
        com.google.android.overtheair.v1.DeleteGroupMembersRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDeleteGroupMembersMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Gets a [group chart][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.Chart> getGroupChart(
        com.google.android.overtheair.v1.GetGroupChartRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetGroupChartMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists [group charts][google.android.overtheair.v1.Chart].
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListGroupChartsResponse> listGroupCharts(
        com.google.android.overtheair.v1.ListGroupChartsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListGroupChartsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists configs of the group. Returns `NOT_FOUND` if the matching path
     * does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListGroupConfigsResponse> listGroupConfigs(
        com.google.android.overtheair.v1.ListGroupConfigsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListGroupConfigsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Update the configs under a group. Returns `NOT_FOUND` if the matching group
     * or config does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.UpdateGroupConfigsResponse> updateGroupConfigs(
        com.google.android.overtheair.v1.UpdateGroupConfigsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdateGroupConfigsMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Disables all enabled groups that have the specified config.
     * Returns `NOT_FOUND` if the matching path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse> disableAllEnabledGroupsOfConfig(
        com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getDisableAllEnabledGroupsOfConfigMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists packages of the config. Returns `NOT_FOUND` if the matching path does
     * not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListConfigPackagesResponse> listConfigPackages(
        com.google.android.overtheair.v1.ListConfigPackagesRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListConfigPackagesMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Update the packages under the config. Returns `NOT_FOUND` if the matching
     * path does not exist.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.UpdateConfigPackagesResponse> updateConfigPackages(
        com.google.android.overtheair.v1.UpdateConfigPackagesRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getUpdateConfigPackagesMethodHelper(), getCallOptions()), request);
    }

    /**
     * <pre>
     * Lists all the configs that use the specified package.
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.google.android.overtheair.v1.ListConfigsUsingPackageResponse> listConfigsUsingPackage(
        com.google.android.overtheair.v1.ListConfigsUsingPackageRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getListConfigsUsingPackageMethodHelper(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_DEPLOYMENT = 0;
  private static final int METHODID_LIST_DEPLOYMENTS = 1;
  private static final int METHODID_UPDATE_DEPLOYMENT = 2;
  private static final int METHODID_GET_PACKAGE = 3;
  private static final int METHODID_LIST_PACKAGES = 4;
  private static final int METHODID_DELETE_PACKAGE = 5;
  private static final int METHODID_UPDATE_PACKAGE = 6;
  private static final int METHODID_CREATE_CONFIG = 7;
  private static final int METHODID_GET_CONFIG = 8;
  private static final int METHODID_LIST_CONFIGS = 9;
  private static final int METHODID_DELETE_CONFIG = 10;
  private static final int METHODID_UPDATE_CONFIG = 11;
  private static final int METHODID_CREATE_GROUP = 12;
  private static final int METHODID_GET_GROUP = 13;
  private static final int METHODID_LIST_GROUPS = 14;
  private static final int METHODID_DELETE_GROUP = 15;
  private static final int METHODID_UPDATE_GROUP = 16;
  private static final int METHODID_DISABLE_GROUPS = 17;
  private static final int METHODID_ENABLE_GROUPS = 18;
  private static final int METHODID_CREATE_GROUP_MEMBER = 19;
  private static final int METHODID_CREATE_GROUP_MEMBERS = 20;
  private static final int METHODID_GET_GROUP_MEMBER = 21;
  private static final int METHODID_LIST_GROUP_MEMBERS = 22;
  private static final int METHODID_DELETE_GROUP_MEMBER = 23;
  private static final int METHODID_DELETE_GROUP_MEMBERS = 24;
  private static final int METHODID_GET_GROUP_CHART = 25;
  private static final int METHODID_LIST_GROUP_CHARTS = 26;
  private static final int METHODID_LIST_GROUP_CONFIGS = 27;
  private static final int METHODID_UPDATE_GROUP_CONFIGS = 28;
  private static final int METHODID_DISABLE_ALL_ENABLED_GROUPS_OF_CONFIG = 29;
  private static final int METHODID_LIST_CONFIG_PACKAGES = 30;
  private static final int METHODID_UPDATE_CONFIG_PACKAGES = 31;
  private static final int METHODID_LIST_CONFIGS_USING_PACKAGE = 32;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final OverTheAirServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(OverTheAirServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_DEPLOYMENT:
          serviceImpl.getDeployment((com.google.android.overtheair.v1.GetDeploymentRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment>) responseObserver);
          break;
        case METHODID_LIST_DEPLOYMENTS:
          serviceImpl.listDeployments((com.google.android.overtheair.v1.ListDeploymentsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListDeploymentsResponse>) responseObserver);
          break;
        case METHODID_UPDATE_DEPLOYMENT:
          serviceImpl.updateDeployment((com.google.android.overtheair.v1.UpdateDeploymentRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Deployment>) responseObserver);
          break;
        case METHODID_GET_PACKAGE:
          serviceImpl.getPackage((com.google.android.overtheair.v1.GetPackageRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package>) responseObserver);
          break;
        case METHODID_LIST_PACKAGES:
          serviceImpl.listPackages((com.google.android.overtheair.v1.ListPackagesRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListPackagesResponse>) responseObserver);
          break;
        case METHODID_DELETE_PACKAGE:
          serviceImpl.deletePackage((com.google.android.overtheair.v1.DeletePackageRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeletePackageResponse>) responseObserver);
          break;
        case METHODID_UPDATE_PACKAGE:
          serviceImpl.updatePackage((com.google.android.overtheair.v1.UpdatePackageRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Package>) responseObserver);
          break;
        case METHODID_CREATE_CONFIG:
          serviceImpl.createConfig((com.google.android.overtheair.v1.CreateConfigRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config>) responseObserver);
          break;
        case METHODID_GET_CONFIG:
          serviceImpl.getConfig((com.google.android.overtheair.v1.GetConfigRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config>) responseObserver);
          break;
        case METHODID_LIST_CONFIGS:
          serviceImpl.listConfigs((com.google.android.overtheair.v1.ListConfigsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsResponse>) responseObserver);
          break;
        case METHODID_DELETE_CONFIG:
          serviceImpl.deleteConfig((com.google.android.overtheair.v1.DeleteConfigRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteConfigResponse>) responseObserver);
          break;
        case METHODID_UPDATE_CONFIG:
          serviceImpl.updateConfig((com.google.android.overtheair.v1.UpdateConfigRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Config>) responseObserver);
          break;
        case METHODID_CREATE_GROUP:
          serviceImpl.createGroup((com.google.android.overtheair.v1.CreateGroupRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group>) responseObserver);
          break;
        case METHODID_GET_GROUP:
          serviceImpl.getGroup((com.google.android.overtheair.v1.GetGroupRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group>) responseObserver);
          break;
        case METHODID_LIST_GROUPS:
          serviceImpl.listGroups((com.google.android.overtheair.v1.ListGroupsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupsResponse>) responseObserver);
          break;
        case METHODID_DELETE_GROUP:
          serviceImpl.deleteGroup((com.google.android.overtheair.v1.DeleteGroupRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupResponse>) responseObserver);
          break;
        case METHODID_UPDATE_GROUP:
          serviceImpl.updateGroup((com.google.android.overtheair.v1.UpdateGroupRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Group>) responseObserver);
          break;
        case METHODID_DISABLE_GROUPS:
          serviceImpl.disableGroups((com.google.android.overtheair.v1.DisableGroupsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableGroupsResponse>) responseObserver);
          break;
        case METHODID_ENABLE_GROUPS:
          serviceImpl.enableGroups((com.google.android.overtheair.v1.EnableGroupsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.EnableGroupsResponse>) responseObserver);
          break;
        case METHODID_CREATE_GROUP_MEMBER:
          serviceImpl.createGroupMember((com.google.android.overtheair.v1.CreateGroupMemberRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember>) responseObserver);
          break;
        case METHODID_CREATE_GROUP_MEMBERS:
          serviceImpl.createGroupMembers((com.google.android.overtheair.v1.CreateGroupMembersRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.CreateGroupMembersResponse>) responseObserver);
          break;
        case METHODID_GET_GROUP_MEMBER:
          serviceImpl.getGroupMember((com.google.android.overtheair.v1.GetGroupMemberRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.GroupMember>) responseObserver);
          break;
        case METHODID_LIST_GROUP_MEMBERS:
          serviceImpl.listGroupMembers((com.google.android.overtheair.v1.ListGroupMembersRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupMembersResponse>) responseObserver);
          break;
        case METHODID_DELETE_GROUP_MEMBER:
          serviceImpl.deleteGroupMember((com.google.android.overtheair.v1.DeleteGroupMemberRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMemberResponse>) responseObserver);
          break;
        case METHODID_DELETE_GROUP_MEMBERS:
          serviceImpl.deleteGroupMembers((com.google.android.overtheair.v1.DeleteGroupMembersRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DeleteGroupMembersResponse>) responseObserver);
          break;
        case METHODID_GET_GROUP_CHART:
          serviceImpl.getGroupChart((com.google.android.overtheair.v1.GetGroupChartRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.Chart>) responseObserver);
          break;
        case METHODID_LIST_GROUP_CHARTS:
          serviceImpl.listGroupCharts((com.google.android.overtheair.v1.ListGroupChartsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupChartsResponse>) responseObserver);
          break;
        case METHODID_LIST_GROUP_CONFIGS:
          serviceImpl.listGroupConfigs((com.google.android.overtheair.v1.ListGroupConfigsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListGroupConfigsResponse>) responseObserver);
          break;
        case METHODID_UPDATE_GROUP_CONFIGS:
          serviceImpl.updateGroupConfigs((com.google.android.overtheair.v1.UpdateGroupConfigsRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateGroupConfigsResponse>) responseObserver);
          break;
        case METHODID_DISABLE_ALL_ENABLED_GROUPS_OF_CONFIG:
          serviceImpl.disableAllEnabledGroupsOfConfig((com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.DisableAllEnabledGroupsOfConfigResponse>) responseObserver);
          break;
        case METHODID_LIST_CONFIG_PACKAGES:
          serviceImpl.listConfigPackages((com.google.android.overtheair.v1.ListConfigPackagesRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigPackagesResponse>) responseObserver);
          break;
        case METHODID_UPDATE_CONFIG_PACKAGES:
          serviceImpl.updateConfigPackages((com.google.android.overtheair.v1.UpdateConfigPackagesRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.UpdateConfigPackagesResponse>) responseObserver);
          break;
        case METHODID_LIST_CONFIGS_USING_PACKAGE:
          serviceImpl.listConfigsUsingPackage((com.google.android.overtheair.v1.ListConfigsUsingPackageRequest) request,
              (io.grpc.stub.StreamObserver<com.google.android.overtheair.v1.ListConfigsUsingPackageResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class OverTheAirServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    OverTheAirServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.google.android.overtheair.v1.OverTheAirServiceProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("OverTheAirService");
    }
  }

  private static final class OverTheAirServiceFileDescriptorSupplier
      extends OverTheAirServiceBaseDescriptorSupplier {
    OverTheAirServiceFileDescriptorSupplier() {}
  }

  private static final class OverTheAirServiceMethodDescriptorSupplier
      extends OverTheAirServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    OverTheAirServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (OverTheAirServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new OverTheAirServiceFileDescriptorSupplier())
              .addMethod(getGetDeploymentMethodHelper())
              .addMethod(getListDeploymentsMethodHelper())
              .addMethod(getUpdateDeploymentMethodHelper())
              .addMethod(getGetPackageMethodHelper())
              .addMethod(getListPackagesMethodHelper())
              .addMethod(getDeletePackageMethodHelper())
              .addMethod(getUpdatePackageMethodHelper())
              .addMethod(getCreateConfigMethodHelper())
              .addMethod(getGetConfigMethodHelper())
              .addMethod(getListConfigsMethodHelper())
              .addMethod(getDeleteConfigMethodHelper())
              .addMethod(getUpdateConfigMethodHelper())
              .addMethod(getCreateGroupMethodHelper())
              .addMethod(getGetGroupMethodHelper())
              .addMethod(getListGroupsMethodHelper())
              .addMethod(getDeleteGroupMethodHelper())
              .addMethod(getUpdateGroupMethodHelper())
              .addMethod(getDisableGroupsMethodHelper())
              .addMethod(getEnableGroupsMethodHelper())
              .addMethod(getCreateGroupMemberMethodHelper())
              .addMethod(getCreateGroupMembersMethodHelper())
              .addMethod(getGetGroupMemberMethodHelper())
              .addMethod(getListGroupMembersMethodHelper())
              .addMethod(getDeleteGroupMemberMethodHelper())
              .addMethod(getDeleteGroupMembersMethodHelper())
              .addMethod(getGetGroupChartMethodHelper())
              .addMethod(getListGroupChartsMethodHelper())
              .addMethod(getListGroupConfigsMethodHelper())
              .addMethod(getUpdateGroupConfigsMethodHelper())
              .addMethod(getDisableAllEnabledGroupsOfConfigMethodHelper())
              .addMethod(getListConfigPackagesMethodHelper())
              .addMethod(getUpdateConfigPackagesMethodHelper())
              .addMethod(getListConfigsUsingPackageMethodHelper())
              .build();
        }
      }
    }
    return result;
  }
}
